#ifndef OBJECT_H
#define OBJECT_H

typedef enum {
    OT_INT,
    OT_FLOAT,
    OT_CONST_STRING,
    OT_NULL,
    OT_BOOL,
    OT_VOID,
    OT_ARRAY,
    OT_REFERENCE
} ObjectType;

typedef struct {
    int pointer;
    int index;
} Reference;

typedef struct {
    ObjectType type;
    union {
        int intValue;
        float floatValue;
        const char* stringValue;
        Reference reference;
    } as;
} Object;

const char* oGetName(ObjectType ot);

#endif